// Last.fm on WoozTalk
// (c) 2009 Kurioos iTech

function dump(msg) {
/*    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage(msg);*/
}

function LOG(msg) {
    dump(msg);
}

var LastFMOnWoozTalk = (function(){try {
	var plugin_name = "lastfm";
	var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;

	var lasturl = null;
	var message = [];
	var wmessage = null;

	var html_entity_decode = function(t) {
	  if (/&[#a-zA-Z0-9]{1,10};/.test(t) == false) {
	    return cleanStr(t);
	  } else {
	    var str = "<div>"+cleanStr(t).replace(/</g, "&lt;").replace(/>/g,"&gt;")+"</div>";
	    var e = (new DOMParser()).parseFromString(str, 'text/xml');
	    if (e.documentElement.nodeName == "parsererror") {
	        return cleanStr(t);
  	    } else {
	        return e.documentElement.textContent;
  	    }
	  }
	}

	var cleanStr = function(s) {
	    return s.replace(/\\0/g,'').replace(/[\n\r]/g,' ').replace(/^[ \t]+/g,'').replace(/[ \t]+$/g,'');
	}

	var sendToWoozTalk = function(args) {
	    if (args.length < 2) {
		if (lasturl != null) {
		    sendCloseURL(lasturl, false);
		}
		lasturl = null;
		unregister_wooztalk();
		return ;
	    }
	    var newurl = "media://"+encodeURIComponent(args[0])+"/"+encodeURIComponent(args[1]);
	    if (lasturl != newurl) {
		register_wooztalk();
		sendOpenURL(newurl);
		if (lasturl != null) {
		    sendCloseURL(lasturl, false);
		}
		lasturl = newurl;
	    }
	}
	
	function update(a) {
	    if(wmessage == a) {
		sendToWoozTalk(message);
	    }
	}
	
	function hide() {
	    sendToWoozTalk([]);
	}

	function callInProgress(xmlhttp) {
	    switch (xmlhttp.readyState) {
		case 1, 2, 3:
		    return true;
		    break;
		    // Case 4 and 0
		default:
		    return false;
		    break;
	    }
	}

	var sendOpenURL = function(url)
	{
	    url = url.toLowerCase();
	    var p = new XMLHttpRequest();
	    var timeoutId = window.setTimeout(function() { if (callInProgress(p)) { p.abort(); } }, 5000);
	    p.onreadystatechange = function(evt) {
		try {
		    if(this.readyState == 4) {
			if (this.responseXML != null) {
			    var count = this.responseXML.documentElement.getAttribute("users");
			    var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			    nbr.value = count;
			} else {
			    var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			    nbr.value = "??";
			}
		    }
		} catch (e) { LOG("Exception open: "+e); }
	    };
	    p.onerror = function(e) {
		if (callInProgress(this)) { 
		    this.abort(); 
		}
		var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
		nbr.value = "WoozTalk not launched?";
	    };
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/open/"+url, true);
	    p.send(null);
	}

	var sendCloseURL = function(url, sync)
	{
	    url = url.toLowerCase();
	    try {
		var p = new XMLHttpRequest();
		var timeoutId = window.setTimeout(function() { if (callInProgress(p)) { p.abort(); } }, 5000);
		if (!sync) {
		    p.onreadystatechange = function() { };
		    p.onerror = function(e) {
			if (callInProgress(this)) { 
			    this.abort(); 
			}
			var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			nbr.value = "WoozTalk not launched?";
		    };
		}
		p.open("GET", "http://localhost:6788/"+plugin_name+"/close/"+url, !sync);
		p.send(null);
	    } catch (e) {
		LOG("Exception in close : "+e);
	    }
	}

	var register_wooztalk = function()
	{
	    var p = new XMLHttpRequest();
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/check/", true);
	    p.send(null);

	    var stat = document.getElementById(plugin_name+'onwooztalk-status');
	    stat.collapsed = false;
	}

	var unregister_wooztalk = function()
	{
	    var p = new XMLHttpRequest();
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/quit/", false);
	    p.send(null);

	    var stat = document.getElementById(plugin_name+'onwooztalk-status');
	    stat.collapsed = true;
	}


	/* Partie spécifique à Last.fm */
	/*
	var pageListener = function(aEvent) {
	    var doc = aEvent.originalTarget;
	    function checkdoc() {
		try {
		    if(!doc 
			    || doc.nodeName != "#document" 
			    || !doc.location 
			    || typeof doc.location.hostname != 'string' 
			    || !doc.location.hostname.match(/lastfm.[A-Za-z]{1,3}$/)
		      )
			throw null; 
		} catch(e) { 
		    return false; 
		} 
		return true;
	    }

	    function detectNewTitle()
	    {
		LOG("detectNewTitle");
		var mainid = doc.getElementById('shoutPost');
		if (mainid == null) {
		    return ;
		}
		var links = mainid.getElementsByTagName("input");
		var author = "";
		var title = "";
		for(var i = 0; i < links.length; i++) {
		    if (links[i].name == "backto") {
			result = links[i].value.match(/\/webclient\/listeningNow\?artist=([^&]*)&track=([^&]*)/);
			if (result != null) {
			    author =  decodeURIComponent(result[1]);
			    title = decodeURIComponent(result[2]);
			    break;
			}
		    }
		}

		if (title != "") {
		    message = [cleanStr(author), cleanStr(title)];
		    wmessage = doc;
		    update(wmessage);
		}
	    }

	    function currentTitleChanged(evt)
	    {
		detectNewTitle();
	    }

	    function checker() {
		if(!checkdoc()) {
		    return false;
		}
		var listenid = doc.getElementById('listen');
		if (listenid) {
		    detectNewTitle();
		    listenid.addEventListener("DOMSubtreeModified", currentTitleChanged, false);
		}
	    }
	    if(checkdoc()) {
		checker();
		doc.defaultView.addEventListener("unload", pageUnloadListener,false);
	    }
	    return true;
	};

	var pageUnloadListener = function(aEvent) {
	    var doc = aEvent.originalTarget;
	    if(doc == wmessage) {
		hide();
	    }
	}

	window.addEventListener("DOMContentLoaded", function() {
		document.getElementById("appcontent").addEventListener("DOMContentLoaded", pageListener,false);
		},false);

	window.addEventListener("unload", function() {
		document.getElementById("appcontent").removeEventListener("DOMContentLoaded", pageListener,false);
		hide();
		},false);
	*/

	var lastfmobserver = { observe : function(httpChannel, osef1, osef2) {
	    try {
		httpChannel.QueryInterface(Components.interfaces.nsIHttpChannel);
		//if(!httpChannel.URI.asciiSpec.match(/webclient\/listeningNow/) { // indexOf('http://post.audioscrobbler.com/') != 0) 
		if(httpChannel.URI.asciiSpec.indexOf('http://post.audioscrobbler.com/') != 0) 
		    return true;
		httpChannel.notificationCallbacks.getInterface(Components.interfaces.nsIWebProgress);
		var win = httpChannel.notificationCallbacks.DOMWindow; 
		// on vérifie qu'on est bien sur le site Last.fm
		// sinon n'importe quel site peut modifier le pseudo en générant une "fausse" requête sur lastfm
		if(!win.location.hostname.match(/^(www)?\.last(fm)?\.[A-Za-z]{1,3}$/)) return true; 
		httpChannel.QueryInterface(Components.interfaces.nsIUploadChannel);
		httpChannel.uploadStream.QueryInterface(Components.interfaces.nsISeekableStream);
		httpChannel.uploadStream.seek(0,0);
		var stream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		stream.init(httpChannel.uploadStream);
		// output contiendra le contenu des données POST
		var output = '';
		var size = stream.available();
		for (var i=0; i<size; i++) {
		    output+=stream.read(1);
		}
		httpChannel.uploadStream.seek(0,0);
		// close() sur les deux streams sinon plantage firefox...
		stream.close();
		httpChannel.uploadStream.close();
		// expression régulière pour extraire le nom du titre et l'artiste
		var tab = (/s=[a-zA-Z0-9]+&a=([^&]+)&t=([^&]+)/).exec(output);
		// on élimine les requêtes qui ne renseignent pas sur le titre en cours de lecture
		if(tab == null) {
		    return true;
		}
		var songobj = {
                     artist : ((tab[1] && tab[1]!='null')?tab[1]:''), 
			      title : ((tab[2] && tab[2]!='null')?tab[2]:''), 
		};
		message = [cleanStr(decodeURIComponent(songobj.artist)),cleanStr(decodeURIComponent(songobj.title))];
		wmessage = win.document;
		update(wmessage);
		// si on quitte, la lecture s'arrête nécessairement, donc on efface le titre :)
		win.addEventListener("unload", function(){ hide(); }, false); 
	    } catch(e) {
		// en cas d'exception, il faut fermer les flux, sinon plantage... 
		if(typeof stream != 'undefined' && stream) stream.close();
		if(typeof httpChannel != 'undefined' && typeof httpChannel.uploadStream != 'undefined' && httpChannel.uploadStream) httpChannel.uploadStream.close();
	    }
	    return true; 
	} };

	Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).addObserver(lastfmobserver, "http-on-examine-response", false);

	window.addEventListener("unload", function() {
		// si on ferme la fenêtre de firefox, on retire l'écouteur de requête
		Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).removeObserver(lastfmobserver, "http-on-examine-response");
		},false);

    var UninstallObserver = {
_uninstall : false,
	     observe : function(subject, topic, data) {
		 if (topic == "em-action-requested") {
		     subject.QueryInterface(Components.interfaces.nsIUpdateItem);

		     if (subject.id == plugin_name+"onwooztalk@wooztalk.com") {
			 if (data == "item-uninstalled") {
			     this._uninstall = true;
			 } else if (data == "item-cancel-action") {
			     this._uninstall = false;
			 }
		     }
		 } else if (topic == "quit-application-granted") {
		     if (this._uninstall) {
			 alert("Merci de relancer WoozTalk pour prendre en compte la désinstallation du plugin.\n\nPlease restart WoozTalk to update plugins' list.");
			 var file_target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name);
			 if (file_target.exists()) {
			     file_target.remove(true);
			 }
		     }
		     this.unregister();
		 }
	     },
register : function() {
	       var observerService =
		   Components.classes["@mozilla.org/observer-service;1"].
		   getService(Components.interfaces.nsIObserverService);

	       observerService.addObserver(this, "em-action-requested", false);
	       observerService.addObserver(this, "quit-application-granted", false);
	   },
unregister : function() {
		 var observerService =
		     Components.classes["@mozilla.org/observer-service;1"].
		     getService(Components.interfaces.nsIObserverService);

		 observerService.removeObserver(this,"em-action-requested");
		 observerService.removeObserver(this,"quit-application-granted");
	     }
	};


	    var get_path = function(id, path) {
		var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		var file = em.getInstallLocation(id).getItemFile(id, path);
		return file;
	    };


	var main = function(event) {
	    var countWindows = function() {
		LOG("countWindows START");
		UninstallObserver.register();
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		    .getService(Components.interfaces.nsIWindowMediator);
		var enumerator = wm.getEnumerator("navigator:browser");
		var counter = 0;
		LOG("Count !");
		while(enumerator.hasMoreElements()) {
		    var win = enumerator.getNext();
		    counter = counter + 1;
		}
		LOG("countWindows END");
		return counter;
	    };

	    var copy_file = function(filename, target)
	    {
		var file_source = get_path(plugin_name+"onwooztalk@wooztalk.com", "install/"+filename);
		var file_target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name+"/"+filename);
		if (!file_source.exists()) {
		    alert("Erreur : fichiers manquants pour compléter l'installation");
		} else if (!file_target.exists() 
			|| Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS == "Linux" ) {
		    file_source.copyTo(target, null);
		}
	    };

	    window.removeEventListener("load", main, false);
	    if (countWindows() == 1) {
		try {
		    var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		    if (!em.getInstallLocation("firefoxonwooztalk@wooztalk.com")) {
			if (osString == "Linux") {
			    alert(plugin_name+" on WoozTalk nécessite l'installation préalable de WoozTalk pour fonctionner.\n\n"+plugin_name+" on WoozTalk requires WoozTalk to run.");
			    window.setTimeout(function() { window._content.document.location = "http://www.wooztalk.com/download/"; }, 2000);
			}
			return ;
		    }

		    var target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk");
		    if (!target.exists()) {
			return ;
		    }

		    var target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name);
		    if (osString == "WINNT") {
			copy_file(plugin_name+".dll", target);
		    } else {
			copy_file("lib"+plugin_name+".so", target);
		    }
		    copy_file(plugin_name+".png", target);
		    copy_file(plugin_name+"_dis.png", target);
		} catch (e) {
		    alert(e);
		}
	    }
	};
	window.addEventListener("load", main, false);
} catch(e) {
    alert('LastFMOnWoozTalk : '+e);
}
})();
